Package: agrmt
Version: 1.42.19
Date: 2026-04-08
Title: Calculate Concentration and Dispersion in Ordered Rating Scales
Authors@R: c(person(given = "Didier",
                  family = "Ruedin",
                  role = c("aut", "cre"),
                  email = "didier.ruedin@unine.ch",
                  comment = c(ORCID = "0000-0001-5213-4316")),
              person(given = "Clem",
                     family = "Aeppli",
                     role = "ctb",
                     comment = c(ORCID = "0000-0002-4003-7938")))
Maintainer: Didier Ruedin <didier.ruedin@unine.ch>
Description: Calculates concentration and dispersion in ordered rating scales. It implements various measures of concentration and dispersion to describe what researchers variably call agreement, concentration, consensus, dispersion, or polarization among respondents in ordered data. It also implements other related measures to classify distributions. In addition to a generic city-block based concentration measure and a generic dispersion measure, the package implements various measures, including van der Eijk's (2001) <DOI: 10.1023/A:1010374114305> measure of agreement A, measures of concentration by Leik, Tatsle and Wierman, Blair and Lacy, Kvalseth, Berry and Mielke, Reardon, and Garcia-Montalvo and Reynal-Querol. Furthermore, the package provides an implementation of Galtungs AJUS-system to classify distributions, as well as a function to identify the position of multiple modes.
License: MIT + file LICENSE
URL: http://agrmt.r-forge.r-project.org
NeedsCompilation: no
Packaged: 2026-04-08 08:00:52 UTC; didier
Author: Didier Ruedin [aut, cre] (ORCID:
    <https://orcid.org/0000-0001-5213-4316>),
  Clem Aeppli [ctb] (ORCID: <https://orcid.org/0000-0002-4003-7938>)
Repository: CRAN
Date/Publication: 2026-04-08 21:40:02 UTC
Built: R 4.5.2; ; 2026-04-08 22:24:32 UTC; unix

agreementError <- function(V, n=500, e=0.01, pos=FALSE) {
  # arguments: V = vector of values (*not* collapsed)
  #            n = number of samples drawn
  #            e = proportion of samples that are errors
  #          pos = vector of possible positions
  #                if FALSE, values in V are set as possible values

  # input validation: is it a vector?
  if(is.vector(V) == FALSE) {
    warning("Warning: Expected a vector, or vector is empty.")
    return(NA)
  }

  # input validation: is the position argument provided?
  # if position argument is not provided, then use the values that occur in the vector as positions
  l <- length(pos)
  if (pos[1] == FALSE & pos[l] == FALSE) pos <- as.numeric(as.data.frame(table(V))[,1])

  # input validation: is the pos argument realistic?
  if (length(pos) < 3) {
    warning("Too few positions to calculate agreement: pos argument ignored.")
    return(NA)
  }

  # define samples to draw from, based on input
  nActual <- round(n*(1-e),0) # how many samples to draw *without* error
  nError  <- n - nActual      # how many samples to draw *with* error
  lenPos  <- length(pos)      # how many positions? (provided or assumed)

  # [1] sample nActual values from V (with replacement)
  sActual <- sample(V, nActual, replace=TRUE)

  # [2] sample nError value from V (with replacement)
  # but add or remove 1 (whilst checking if result is within bounds)
  sError <- NULL              # empty to start with
  for(i in 1:nError){
    s <- sample(V, 1, replace=TRUE) # pick a random position
    # add error:
    m <- match(s, pos)        # at which position of pos is the sampled value
    e <- sample(c(-1,0,1),1)  # simulated error
    x <- pos[m+e]             # matched position +/- 1 or exact
      if(m==1) {              # if furthest to left
      e1 <- sample(c(0,1),1)  # censored: cannot become more negative
      x <- pos[m+e1]          # matched position +1 or exact
    }
    if(m==lenPos) {           # if furthest to right
      e2 <- sample(c(-1,0),1) # censored: cannot become more positive
      x <- pos[m+e2]          # matched position -1 or exact
    }
    sError <- c(sError,x)     # add modified (with error) to sample of errors
  }

  # [3] combine samples, and calculate agreement
  sCombined <- c(sActual, sError)
  a <- agreement(collapse(sCombined, pos=pos))
  # now I simply need to run error.agreement() a few (hundred) times
  # and can run the summary statistics on the result (mean, median, SD etc.)
  # z <- replicate(1000, error.agreement(V))
  # mean(z) # etc.
  return(a)
}

patternVector <-
function(V) {
   # Creates pattern vector from frequency vector
   # Argument: V = frequency vector
   k <- length (V) # number of categories
   P <- NULL       # prepare empty P
   for (i in 1:k) {
      if (V[i] == 0) (P[i] <- 0)     # 0 remains 0
      else (P[i] <- 1)               # everything else becomes 1
   }
   return (P)
   }

entropy <- function(V) {
# calculates the Shannon entropy, following Tatsle & Wierman (2007)
  V <- V/sum(V)    # normalizing the vector
  a <- log2(V)     # log2 separately, so I can filter out the -Inf
  # this is how Tatsle & Wierman handle it!
  a[a==-Inf] <- 0  # if log(0), then 0
  e <- -1 * sum(V * a)
  return(e)
}

consensus = function(V) {
# calculate consensus, according to Tatsle & Wierman (2007)
# arguments:   V = frequency vector

  # input validation: is this a frequency vector?
  if (min(V) < 0) stop("Error: negative values found in frequency vector.")
  if (all(round(V,0) == V) == FALSE) stop("Error: not all values are whole numbers; not a frequency vector; multiply by 100?")

  P = V/sum(V) # normalizing the vector
  pos = 1:length(V)
  mx = mean(expand(V))
  dx = max(pos) - min(pos)
  cns = 1 + sum(P * log2(1-abs(pos-mx)/dx))
  # mathematically, consensus is not defined when all observations are the same
  # but by definition this is 1 (one):
  if (max(V)==sum(V)) cns = 1
  return(cns)
}

ajusCheck <- function(V, t=seq(from=0.05, to=0.2, by=0.05), variant="modified") {
# sensitivity check for AJUS (how does chaning the tolerance parameter affect results)
# arguments: V: vector describing the distribution
#            t: vector of tolerance values to test
#            variant: "strict" (AJUS) or "modified" (AJUSFL)
# type:
type <- sapply(t, function(x) ajus(V, tolerance=x, variant=variant)$type)
# same for skew:
skew <- sapply(t, function(x) ajus(V, tolerance=x, variant=variant)$skew)
r <- list(tolerance = t, type = type, skew = skew)
return(r)
}

Leik <- function (V) {
   # Leik (1966) A Measure of Ordinal Consensus
   # Argument: V = vector containing frequnecy distribution ("frequency vector")
   n <- sum(V)     # sum of all values
   m <- length(V)  # number of categories
   P <- V/n        # percentages
   R <- cumsum(P)  # cumulative frequency distribution
   SDi <- sapply(1:m, function(x) ifelse(R[x] <= .5, R[x], 1-R[x]))  # Differences, eqn.1
   maxSDi <- .5*(m-1)             # Maximum possible SDi given n, eqn.2
   D <- sum(SDi)/maxSDi           # ordinal dispersion; standardized, eqn.3
   return(D)
   }

D.variance = function(V) {
  # Calculate the approximate variance of Leik's (1966) D (L1)
  # V should be a frequency vector
  # Based off of Blair and Lacy 2000: 274
  
  N = sum(V)
  k = length(V)
  p = V/N
  F = cumsum(p)
  
  a = rep(x = 0, times = k) #(k - 1:k)*2/(k-1)
  for(i in 1:k) {
    F.ghalf = (F >= 1/2)*1
    F.lhalf = (F < 1/2)*1
    npos = sum(F.ghalf[i:k])
    nneg = sum(F.lhalf[i:k])
    a[i] = (npos - nneg)* 2 / (k-1)
  }
  
  D.var = (sum(p * a^2) - sum(p * a)^2)/N
  return(D.var)
}

patternAgreement <-
function(P, old=FALSE) {
   # Calculates agreement A from a pattern vector
   # Arguments:   P = pattern vector
   #            old = use old Unimodality algorithm (passed on)
   # Example: Second pattern on p.333: P <- c(1,0,1,0,0,0,0)
   if (max(P) > 1) stop("Error: Input is not a pattern vector (only 0 and 1 are allowed).")
   # This error should never occur unless the function is called directly.
   K <- length(P)                     # number of categories
   # Counting triplets
   TDU <- 0                           # begin with count = 0, prepare
   TU  <- 0                           # begin with count = 0, prepare
   for (i in 1:(K-2)) {               # repeat for position A
      for (j in (i+1):(K-1)) {        # repeat for position B
         for (m in (j+1):K) {         # repeat for position C
	    if (P[i] == 1 & P[j] == 0 & P[m] == 1) TDU <- TDU + 1 # 101 pattern, bimodal (TDU)
	    if (P[i] == 1 & P[j] == 1 & P[m] == 0) TU <- TU + 1   # 110 pattern, unimodal (TU)
	    if (P[i] == 0 & P[j] == 1 & P[m] == 1) TU <- TU + 1   # 011 pattern, unimodal (TU)
	    # all other patterns are not counted
	 }
      }
   }
   if (old==TRUE) (U <- (TU-TDU)/(TU+TDU))           # using the old algorithm (outlined in endnotes)
   else (U <- ((K-2)*TU-(K-1)*TDU)/((K-2)*(TU+TDU))) # normal case: U as in equation (2) on p.332
   S <- sum(P)                        # number of non-empty
   A <- U*(1-(S-1)/(K-1))             # calculating agreement A
   if (is.nan(A)) (A <- 0)            # lack of agreement, defined as 0
   if (sum(P) == 1) (A <- 1)          # only one value, defined as 1
   return(A)
   }

polarization <-
function (V, old=FALSE) {
   # Calculates polarization (SOM Project)
   # Arguments: as Agreement function (V = frequnecy vector)
   p <- (1 - agreement(V,old))/2  # pass arguments to agreement function, rescale
   return(p)
   }

consensus.variance = function(V) {
  # Calculate the approximate variance of the consensus (Cns) estimator
  # V should be a frequency vector
  # Based off of Blair and Lacy 2000: 274
  k = length(V)
  N = sum(V)
  p = V / N
  mu = mean(expand(V))
  dX = max(expand(V)) - min(expand(V))
  
  jge = ((1:k) < mu) * 2 - 1
  const = - sum(p * jge / ((1 - abs(1:k - mu)/dX)*log(2)*dX))
  a = (1:k)*const + log2(1 - abs(1:k - mu)/dX)
  consensus.var = (sum(p * a^2) - sum(p * a)^2)/N
  
  return(consensus.var)
}

Reardon = function(V) {
  # Calculate Reardon's (2009) entropy
  K = length(V)
  Fi = cumsum(V/sum(V))
  summand = Fi*log2(1/Fi) + (1 - Fi)*log2(1/(1 - Fi))
  summand[is.na(summand)] = 0 # NA from log2() replaced
  r = (1/(K-1)) * sum(summand[1:(K-1)]) # sum only the first K-1 terms
  return(r)
}

agreement <-
function(V, old=FALSE) {
   # Calculates agreement A for multiple layers
   # Arguments:  V = frequency vector
   #           old = use old Unimodality algorithm
   # Example: V <- c(30,40,210,130,530,50,10)
   if (length(V) < 3 ) {
      warning("Warning: length of vector < 3, agreement A is not defined.")
      return(NA)}
   if (min(V) < 0) stop("Error: negative values found in frequency vector.")
   # This error only occurs if the input is not a frequency vector. Use collapse() to generate a frequency vector.
   AA <- 0        # begin with empty agreement A (overall), prepare
   k <- length(V) # number of categories
   N <- sum(V)    # number of cases
   R <- V         # remainder
   for (i in 1:k) {                  # repeat for each layer i
      P <- patternVector(R)          # get the pattern vector for layer i
      if (max(P) == 0) break         # remainder is empty, all layers are analyzed
      A <- patternAgreement(P, old)  # agreement A for layer i
      m <- minnz(R)                  # get non-zero minimum of remainder R
      L <- P * m                     # layer i with the values
      w <- sum(L)/N                  # weight of layer i
      AA <- AA + w * A               # adding agreement of layer i to overall agreement
      R <- R - L                     # new reminder
   }
   return(AA)
   }

compareValues <-
function(A,B,tolerance=0.1) {
  # Helper function: How do two values compare?
  # Arguments: A = value 1
  #            B = value 2
  #    tolerance = tolerance (absolute value, default 0.1)
  if (A > B) r <- -1 else r <- 1 # A is bigger: relationship -1; B is bigger: relationship 1
  if (abs(A-B)-tolerance <= 0) r <- 0
  return(r)
  }

disper = function(A, B, metric = 2) {
  # measure of dispersion
  # input validation:
  if(length(A) != length(B) | length(A) == 0) stop("Error: A and B must have the same nonzero length")
  if(metric <= 0) stop("Error: metric must be greater than 0")
  # special case
  if(metric == Inf) { return(max(abs(A - B))) }
  # normal case
  return((sum(abs(A - B)^metric))^(1/metric))
}

concentration <- function(V, metric = 2) {
  # measure of concentration
  V_F = cumsum(V/sum(V))              # empirical CMF
  k = length(V_F)
  V_Fk = V_F[1:(k-1)]                 # F up to k-1
  maxdisp_Fk = rep(x = 1/2, k - 1)    # the CMF for the point of maximal dispersion
  maxconc_Fk = c(1,rep(x = 0, k - 2)) # the CMF for the point of maximal concentration
  
  D = disper(V_Fk, maxdisp_Fk, metric)
  D_max = disper(maxdisp_Fk, maxconc_Fk, metric)
  return(D/D_max)
}

l.variance = function(V) {
  # Calculate approximate variance of Blair and Lacy's (2000) l (L2)
  # V should be a frequency vector
  # From Blair and Lacy 2000: 274
  lsquared = concentration(V,2)^2
  l.var = lsquared.variance(V)/(4 * lsquared)
  return(l.var)
}

ajusPlot <- function(V, tolerance=0.1, variant="modified", ...) {
# plot AJUS with additional information
# additional arguments can now be passed on (e.g col="red", lwd=2)
# removing NA to deal with real-life data
# (e.g. time series with missing data)
a <- ajus(na.omit(V), tolerance=tolerance, variant=variant) # do not consider missing values
l <- length(V)          # for plotting
m <- max(V, na.rm=TRUE) # for plotting
i <- min(V, na.rm=TRUE) # for difference d
d <- m - i              # for plotting
#plot(V, type="b", axes=FALSE, xlab="", ylab="")
miss <- !is.na(V)   # for which years do data exist?
plot(which(miss), na.omit(V), type="b", axes=FALSE, xlab="", ylab="", xlim=c(1,l), ...) # plot where data exist
axis(1, at=1:l) # control axes
axis(2)
if (m==0) m <- 1 # avoid plotting type on line if "F" at 0
if (d==0) d <- m # avoit plotting type on line if "F"
text(1+l/5, m-d/5, paste("type", a$type, sep=" "), cex=2)
text(1+l/5, m-d/3, paste("skew", a$skew, sep=" "))
}

sd.variance = function(V) {
  # Calculate the approximate variance of the categorical standard deviation
  # V should be a frequency vector
  var = var(expand(V))
  sd.var = var.variance(V)/(4 * var)
  return(sd.var)
}

secondModes <-
function(V, pos=FALSE, tolerance=0.1) {
  m1 <- modes(V, tolerance=tolerance, pos=pos)
  V2 <- V[-m1$positions]
  m2 <- modes(V2, tolerance=tolerance, pos=pos)
  a <- list(m1$at, m2$at)
  f <- list(m1$frequencies, m2$frequencies)
  m <- list(m1$mode, m2$mode)
  p <- list(m1$positions, m2$positions)
  c <- list(m1$contiguous, m2$contiguous)
  r <- list(at = a, frequencies = f, mode = m, positions = p, contiguous = c)
  # compare output to modes()
  return(r)
  }

collapse =
  function(D, pos=FALSE, na.rm=TRUE) {
    # Calculates a frequency vector F from a population vector D
    # Arguments:  D  = population vector
    #            pos = positions of the categories
    #                  (necessary if categories with 0 observations exist)
    #                  if not provided, we assume observations in all categories
    #          na.rm = NA are removed (default)
    if(na.rm == TRUE) {
      # remove NA from vector, as.numeric() to get back the vector
      D = as.numeric(na.omit(D))
      }
    if(is.vector(D) == FALSE) {
      # check if we have a vector
      warning("Warning: Expected a vector, or vector is empty.")
      return(NA)}
    if(is.numeric(D[1]) == FALSE) {
      # check if we have numbers in the vector
      warning("Warning: Expected a numeric value in the vector.")
      return(NA)}
    if(is.na(D[1]) == TRUE) {
      # fail with warning if NA are found or empty
      warning("Warning: Expected a vector, vector is empty, or vector starts with NA.")
      return(NA)}
    if(na.rm==TRUE){T = as.data.frame(table(D))}                  # table(D) to count frequencies
    else{T = as.data.frame(table(D, useNA="ifany"))}  # table(D) to count frequencies
    F = T[,2]                    # [,2] chooses the values
    l = length(pos)              # number of categories specified
    if (!(pos[1] == FALSE & pos[l] == FALSE)) {   # number of positions is provided:
      # if first value of pos is not zero, and last value is not zero
      F2 = F           # source of values
      k = length(pos)  # number of positions
      F = rep(0,k)     # empty with length(k)
      V = unique(D)    # chooses the categories (positions) of the values in F2
      V = V[!is.na(V)] # remove NA from unique values
      V = sort(V)      # keep order that is messed up by the preceding line
      m = length(V)    # number of non-zero values to be filled into F
      for(i in 1:m) {
        for(j in 1:k) {
          if (pos[j] == V[i]) F[j] = F2[i] # fill in frequencies at the correct positions
        }
      }
    }
    return(F)
  }

lsquared.variance = function(V) {
  # Calculate approximate variance of Blair and Lacy's (2000) lsquared (L2^2)
  # V should be a frequency vector
  # From Blair and Lacy 2000: 274
  k = length(V)
  i = 1:length(V)
  N = sum(V)
  pi = V/N
  
  a = (k - 1:k)/2
  for(i in 1:(k-1)) {
    a[i] = a[i] + sum((i - ((i+1):k))*pi[(i+1):k])
  }
  
  lsquared.var = 64*(sum(pi * a^2) - (sum(pi * a))^2)/(N*((k-1)^2))
  return(lsquared.var)
}

reduceVector <-
function(X) {
  # Helper function to remove all zeros, and then remove repeated values
  # Argument: vector
  X <- X[!X==0]             # remove all 0 from X
  n <- length(X)
  Z <- X[1]                 # first item of X is set in Z
  for (i in 2:n) {          # for all subsequent items in Z
    if (!X[i] == X[i-1]) Z <- c(Z,X[i]) # if items is not the same, add it to Z
    }
  return(Z)
  }

compareAgreement <- function(V, n=500, e=0.01, N=500, pos=FALSE) {
  #            V = vector of values (*not* collapsed)
  #            n = number of values to sample in error.agreement
  #            e = proportion of errors to sample in error.agreement
  #            N = number of replications for mean and standard deviation
  #          pos = positions

  # if position argument is not provided, then use the values that occur in the vector as positions
  l <- length(pos)
  if (pos[1] == FALSE & pos[l] == FALSE) pos <- as.numeric(as.data.frame(table(V))[,1])

  # input validation: enough values is pos to calculate agreement?
  if (length(pos) < 3) {
    warning("Too few positions to calculate agreement.")
    return(NA)
  }
  a <- agreement(collapse(V, pos=pos))
  z <- replicate(N, agreementError(V, n=n, e=e, pos=pos))
  return(list(agreement=a, mean=mean(z), sd=sd(z)))
}

dsquared <- function(V) {
# calculate ordinal concentration, following Blair & Lacy 2000
# argument: V = frequency vector
k <- length(V) # number of categories
n <- sum(V)    # number of cases
V <- V/n       # standardizing
# from 1 to k-1(Fi -.5)^2
dsq <- sum(sapply(1:(k-1), function(x) (sum(V[1:x]) - .5)^2))
return(dsq)
}

modes <-
function(V, pos=FALSE, tolerance=0.1) {
  # Find (multiple) modes of frequency vector (roughly the same frequencies)
  # Arguments:    V = frequency vector
  #             pos = positions of categories
  #       tolerance = tolerance to consider values the same (absolute values)
  # Example 1: modes(c(30,40,210,130,530,50,10)) # will find position 5
  # Example 2: modes(c(3,0,4,1))                 # will find position 3
  # Example 3: modes(c(3,0,4,1),pos=-1:2)        # will still find position 3, but give the value of 1 as mode
  # Example 4: modes(c(30,40,500,130,530,50,10),tolerance=30) # will find positions 3 and 5 (500 and 530 nearly same as in the difference smaller or equal to the tolerance)
  if (min(V) < 0) stop("Error: negative values found in frequency vector.")      # input validation
  # This error only occurs if the input is not a frequency vector. Use collapse() to generate a frequency vector.
  if (!pos[1]==FALSE) if (is.numeric(pos) == TRUE) { # input validation: if pos argument is provided
    if (!length(pos) == length(V)) { # pos vector of different length
       warning("Note: length of position vector different from length of frequency vector. Position vector ignored")
       pos <- FALSE } # simply ignore it, better than stopping outright
       }
  k <- length(V)  # number of values
  p <- NULL       # empty for preparation
  if (pos[1]==FALSE) if (is.numeric(pos) == FALSE) pos <- 1:k # no positions provided, assume 1:k (no zero)
  m <- which.max(V) # position of mode
  for (i in 1:k) {  # check each position to see if it is equal to the mode
    # because of the tolerance, frequencies need not be exactly the same
    if (compareValues(V[i],V[m],tolerance=tolerance)==0) p <- c(p,i) # add position of the mode
  }
  # Check whether modes are contiguous (= agreement) (c = {"contiguous", "divided"}
  if ((max(p) - min(p)) < length(p)) c <- TRUE else c <- FALSE
  r <- list(at = pos, frequencies = V, mode = pos[p], positions = p, contiguous = c)
  # at = positions or categories of vector, either given (argument "pos")
  #      or set to 1:k
  # frequencies = frequency vector V (provided)
  # mode = mode(s) of V, considering the categories of the vector
  # positions = position of V at which mode is found
  # contiguous = TRUE/FALSE if modes are contiguous
  return(r)
  }

MRQ <- function(Z) {
  # polarization index (Montalvo and Reynal-Querol 2005); cited in Ziller 2014
  z <- length(Z)
  # standardizing frequency vector if necessary
  if (!sum(Z) == 1) Z <- Z/sum(Z)
  4 * sum(Z[1:z]^2*(1-Z))
  }

isd <-
function(V, tolerance=0.1) {
  # Classification over time (ISD-system)
  # Arguments:         V = vector with values at 3 time points (transition points)
  #            tolerance = tolerance (absolute)
  # Example: V <- c(10,10,0)
  if (!length(V) == 3) {warning("Warning: no vector with three time points.") # input validation
      r <- list(type= NA, description = NA) # returning NA for both type and skew (so we can use ISD()$type)
      return(r)}
  x    <- NULL
  x[1] <- compareValues(V[1],V[2], tolerance=tolerance)
  x[2] <- compareValues(V[2],V[3], tolerance=tolerance)
  if (x[1]==1  & x[2]==1)  I <- list(type=1, description="increase, increase")
  if (x[1]==1  & x[2]==0)  I <- list(type=2, description="increase, flat")
  if (x[1]==1  & x[2]==-1) I <- list(type=3, description="increase, decrease")
  if (x[1]==0  & x[2]==1)  I <- list(type=4, description="flat, increase")
  if (x[1]==0  & x[2]==0)  I <- list(type=5, description="flat, flat")
  if (x[1]==0  & x[2]==-1) I <- list(type=6, description="flat, decrease")
  if (x[1]==-1 & x[2]==1)  I <- list(type=7, description="decrease, increase")
  if (x[1]==-1 & x[2]==0)  I <- list(type=8, description="decrease, flat")
  if (x[1]==-1 & x[2]==-1) I <- list(type=9, description="decrease, decrease")
  return(I)
  }

minnz <-
function(V) {
   # Calculates the smallest value of the vector except for 0 (non-zero minumum)
   # Argument: vector
   C <- NULL        # prepare
   k <- length(V)   # count to
   for (i in 1:k) { # ceck all
      if ((V[i] == 0) == FALSE) (C[i] <- V[i]) else (C[i] <- 9999919) # if V[i] is not 0, add it to C
   }
   m <- min(C)               # minimum of V, not counting 0
   if (max(V) == 1) (m <- 1) # fix for binary vectors (0,1)
   if (m == 9999919) (warning("Error: Minimum calculation failed."))  # warning because of hard-coded replacement
   return(m)
   }

ajus <-
function(V, tolerance=0.1, variant="modified") {
  # Determine the shape of a distribution
  # Arguments:         V = frequency vector
  #            tolerance = tolerance (absolute value)
  #              variant = "strict" for AJUS, "modified" for AJUSFL
  # Example: V <- c(30,40,210,130,530,50,10)
  if (min(V) < 0) stop("Error: negative values found in frequency vector.") # input validation
  # (1) identify patterns: 0 flat, 1 increase, -1 decrease
  n <- length(V)    # number of items
  z <- n-1          # number of breaks
  if (n < 3) {warning("Warning: too few values to classify distribution.") # input validation
      r <- list(type=NA, skew=NA) # returning NA for both type and skew (so we can use AJUS()$type)
      return(r)}
  x <- NULL         # prepare
  for (i in 1:z) {
    x[i] <- compareValues(V[i], V[i+1], tolerance=tolerance)
    }
  # Example vector V gives x = c(1  1 -1  1 -1 -1)
  # or with tolerance=.5:  x = c(0  1  0  1 -1 -1)
  # (2) identify shape
  min.x <- min(x)
  max.x <- max(x)
  if (min.x == 0 & max.x == 0 & compareValues(V[1], V[n], tolerance=tolerance) == 0) A <- "F" else {    # flat distribtion, type F not in AJUS
    if (max.x <  1) A <- "J" else {      # no 1,  thus only 0 or + 1 (single peak at left end)  -- "L"
      if (min.x > -1) A <- "J"  else {   # no -1, thus only 0 or 1   (single peak at right end) -- "J"
        xs <- reduceVector(x)            # remove 0 and repeated values; not use unique(), because I want same values at different positions ("type S")
        if (isTRUE(all.equal(xs, c(1,-1)))) A <- "A" else {
          # isTRUE(all.equal(V[i],m)
          if (isTRUE(all.equal(xs, c(-1,1)))) A <- "U" else A <- "S"
        }
      }
    }
  }
  # F if: flat, no peak;                polarization; all 0
  # A if: unimodal, peak in the middle; consensus;    0 or +1, then 0 or -1
  # J if: unimodal, peak at either end; consensus;    0 or + 1, xor 0 or -1
  # U if: bimodal,  peak at both ends;  polarization; 0 or -1, then 0 or +1
  # S if: bimodal,  multiple peaks;     polarization; else
  # (3) identify skew
  m <- round(n/2,0) # midpoint of vector V
  S <- compareValues(sum(V[1:m]),sum(V[m:n]), tolerance=tolerance) # S = skew [-1,0,+1] (negative, symmetric, positive)
  # manually set skew for "J" type distributions (necessary because long tails can change value S):
	if (A == "J" & max.x < 1)  S <- -1 # single peak at left end  -- "L"
	if (A == "J" & min.x > -1) S <- 1  # single peak at right end -- "J"
  # "strict" versus "modified"
  if (variant == "strict" & A == "F") A <- NA              # "F" not defined in AJUS strict
  if (variant == "modified" & A == "J" & S == -1) A <- "L" # "L" as modified type
  r <- list(type = A, skew = S, pattern = x)
  return(r)
  }

lsquared <- function(V) {
# measure of concentration, following Blair & Lacy 2000
# argument: V = frequency vector
## k <- length(V) # number of categories
## lsq <- dsquared(V)/((k-1)/4)
## return(lsq)
lsq = concentration(V, 2)^2
return(lsq)
}

BerryMielke <- function(V) {
  # IOV, as cited in Blair & Lacy 2000
  # argument: V = frequency vector
    N <- sum(V)    # sample size
    k <- length(V) # number of categories
  # t  = sum from i=1 to k-1 ( sum from j = i+1 to k (ni*nj*(i-j)) )
  # ni, nj = cell counts; i, j = values of categories
    t <- sum(sapply(1:(k-1), function(i) sum(sapply((i+1):k, function(j) V[i]*V[j]*(j-i)))))
  # Tmax not defined with odd numbers; use (N^2-1)*(k-1)/4 instead (although differences small)
    Tmax <- N^2*(k-1)/4
  # if N odd:
    if(N%%2 == 1) (Tmax <- (N^2-1)*(k-1)/4) # %%: integer division, gives 1 if odd, gives 0 if even
  iov <- t/Tmax
  return(iov)
}

expand <- function(F) {
  # Converts frequency vector in a population vector
  # Argument: F = frequency vector
  # Example: F <- c(10,20,34,5)
  # input validation: is this a frequency vector?
  if (min(F) < 0) stop("Error: negative values found in frequency vector.")
  if (all(round(F,0) == F) == FALSE) stop("Error: not all values are whole numbers; not a frequency vector; multiply by 100?")

  k <- length(F) # prepare expansion
  D <- NULL      # prepare expansion
  for (i in 1:k) {
    D <- c(D,rep(i,F[i]))   # expand
  }
  return(D)      # population vector
}

var.variance = function(V) {
  # Calculate the approximate variance of the categorical variance estimator
  # V should be a frequency vector
  # Based off of Blair and Lacy 2000: 274
  k = length(V)
  N = sum (V)
  p = V / N
  mu = mean(expand(V))
  
  const = -sum(2*p*((1:k)-mu))
  a = (N / (N - 1)) * ((1:k) * const + ((1:k) - mu)^2)
  
  var.var = (sum(p * a^2) - (sum(p * a))^2)/N
  return(var.var)
}

\name{truncatevector}
\alias{truncatevector}
\title{Truncate helper function}
\description{Helper function to truncate frequency vectors}
\usage{truncatevector(V, left=0, right=100)}
\arguments{
  \item{V}{Vector}
  \item{left}{left to truncate}
  \item{right}{right to truncate}
}
\details{Helper function to truncate frequency vectors}

\value{truncated frequency vector}
\author{Clem Aeppli}
\seealso{\code{\link{censor}}}

\name{reduceVector}
\alias{reduceVector}
\title{Remove zeros and repeated values}
\description{This is a helper function to remove all zeros and repeated values from a vector.}
\usage{reduceVector(X)}
\arguments{\item{X}{A (frequency) vector}}
\details{This is a helper function to strip all zeros and repeated values from a vector.}
\value{The function returns vector}
\author{Didier Ruedin}
\seealso{\code{\link{agreement}}}

\name{ajusPlot}
\alias{ajusPlot}
\title{Plot vector with AJUS type}
\description{Plot a frequency vector among with its AJUS type.}
\usage{ajusPlot(V, tolerance=0.1, variant="modified", ...)}
\arguments{
  \item{V}{A frequency vector}
  \item{tolerance}{Specify how similar values have to be to be treated as different (optional). Differences smaller than or equal to the tolerance are ignored.}
  \item{...}{Arguments to pass to the plotting function}
  \item{variant}{Strict AJUS following Galtung, or modified to include F and L types (default)}
}
\details{This function plots the frequency vector along with its AJUS classification and skew. See \code{\link{ajus}} for a description of the AJUS system and the different parameters. In contrast to the \code{ajus} function, \code{ajusPlot} can deal with missing values. Missing values are removed when calculating the AJUS type (because AJUS does not handle missing values), but they are considered in the plot. This makes \code{ajusPlot} useful for classifying time series where missing values may occur. Additional arguments can be passed to the underlying \code{plot} function.}
\author{Didier Ruedin}
\seealso{\code{\link{ajus}}}

\name{disper}
\alias{disper}
\title{Measures distance}
\description{This function measures distance between two frequency vectors}
\usage{disper(A, B, metric=2)}
\arguments{
  \item{A}{Vector}
  \item{B}{Vector}
  \item{metric}{city block metric}
}
\details{Calculates the distance between two frequency vectors.}

\value{measure of distance}
\author{Clem Aeppli}
\seealso{\code{\link{concentration}}}

\name{expand}
\alias{expand}
\title{Expands a frequency vector to a vector}
\description{This function expands a frequency vector to a vector.}
\usage{expand(F)}
\arguments{
  \item{F}{Frequency vector}
}
\details{This function takes a frequency vector and expands it to a longer vector with one entr for each observation. It is reverses the \code{\link{collapse}} function. A frequency vector has an entry for each position in the population. Each entry states the number of individuals in the population with this position. Here we create a vector with an entry for each individual.}

\value{A vector}
\author{Didier Ruedin}
\seealso{\code{\link{collapse}}}

\name{var.variance}
\alias{var.variance}
\title{Approximate variance of the consensus (Cns) estimator}
\description{Calculate approximate variance of the consensus (Cns) estimator}
\usage{var.variance(V)}
\arguments{
  \item{V}{Frequency vector}
}
\details{Helper function to calculate approximate variance of the Consensus (Cns) estimator.}

\value{Approximate variance of Blair and Lacy's l}
\references{Blair, J., and M. Lacy. 2000. Statistics of Ordinal Variation. Sociological Methods & Research 28 (3): 251-280.}
\author{Clem Aeppli}
\seealso{\code{\link{consensus}}}

\name{patternVector}
\alias{patternVector}
\title{Creates pattern vector}
\description{Helper function to create a pattern vector from a frequency vector.}
\usage{patternVector(V)}
\arguments{\item{V}{A frequency vector}}
\details{This is a helper function to create a pattern vector from a frequency vector. A pattern vector reduced all values greater or equal to 1 to 1, and values of 0 remain 0. A frequency vector (0,0,18,59,0,34,2) is turned into a pattern vector (0,0,1,1,0,1,1).}
\value{The function returns a pattern vector.}
\author{Didier Ruedin}
\seealso{\code{\link{agreement}}}

\name{consensus.variance}
\alias{consensus.variance}
\title{Approximate variance of consensus}
\description{Calculate approximate variance of Blair and Lacy's consensus Cns}
\usage{consensus.variance(V)}
\arguments{
  \item{V}{Frequency vector}
}
\details{Helper function to calculate approximate variance of Blair and Lacy's (2000) consensus Cns.}

\value{Approximate variance of Blair and Lacy's consensus Cns}
\references{Blair, J., and M. Lacy. 2000. Statistics of Ordinal Variation. Sociological Methods & Research 28 (3): 251-280.}
\author{Clem Aeppli}
\seealso{\code{\link{consensus}}}

\name{dsquared}
\alias{dsquared}
\title{Calculate d-squared}
\description{Calculate Blair and Lacy's d-squared.}
\usage{dsquared(V)}
\arguments{
  \item{V}{A frequency vector}
}
\details{This function calculates Blair and Lacy's d-squared, a measure of concentration based on squared Euclidean distances. This function follows the presentation by Blair and Lacy 2000. The measure l-squared normalizes the values and is implemented as \code{\link{lsquared}}.}
\value{The function returns the d-squared.}
\references{Blair, J., and M. Lacy. 2000. Statistics of Ordinal Variation. Sociological Methods & Research 28 (3): 251-280.}
\author{Didier Ruedin}
\seealso{\code{\link{lsquared}}, \code{\link{BlairLacy}}}
\examples{
# Sample data
V <- c(30,40,210,130,530,50,10)
dsquared(V)
}

\name{patternAgreement}
\alias{patternAgreement}
\title{Calculates patterns agreement}
\description{Helper function to calculate agreement A from a pattern vector.}
\usage{patternAgreement(P, old=FALSE)}
\arguments{
\item{P}{A pattern vector}
\item{old}{Optional argument if the old algorithm for agreement A is to be used. There is normally no reason to set the \code{old} argument.}
}
\details{This is a helper function to calculate agreement A from a pattern vector.}
\value{The function returns the measure of agreement A}
\author{Didier Ruedin}
\seealso{\code{\link{agreement}}}

\name{minnz}
\alias{minnz}
\title{Non-zero minimum}
\description{Helper function to calculate the smallest value of the vector except for 0 (non-zero minimum).}
\usage{minnz(V)}
\arguments{\item{V}{A vector}}
\details{This is a helper function to calculate the non-zero minimum of a vector. The result is the smallest value of the vector, but cannot be zero.}
\value{The function returns the non-zero minimum}
\author{Didier Ruedin}

\name{Kvalseth}
\alias{Kvalseth}
\title{Calculate Kvalseth's COV}
\description{Calculate Kvalseth's COV.}
\usage{Kvalseth(V)}
\arguments{
  \item{V}{A frequency vector}
}
\details{This function calculates Kvalseth's COV, a measure of dispersion based on linear Euclidean distances. It is based on the IOV measure, implemented as \code{\link{BerryMielke}}. This function follows the presentation by Blair and Lacy 2000.}
\value{The function returns the COV.}
\references{Blair, J., and M. Lacy. 2000. Statistics of Ordinal Variation. Sociological Methods & Research 28 (3): 251-280.}
\author{Didier Ruedin}
\seealso{\code{\link{BerryMielke}}, \code{\link{lsquared}}}
\examples{
# Sample data
V <- c(30,40,210,130,530,50,10)
Kvalseth(V)
}

\name{MRQ}
\alias{MRQ}
\title{Calculates MRQ polarization index}
\description{This function calculates the MRQ polarization index from a population vector.}
\usage{MRQ(Z)}
\arguments{ \item{Z}{(Standardized) frequency vector}}
\details{This function implements the polarization index introduced by Garcia-Montalvo
and Reynal-Querol (2005), also known as the Reynal-Querol index of polarization (RQ). It is a measure of dispersion based on squared Euclidean distances. The frequency vector needs to be standardized for the Reynal-Querol index to work; if the sum of the frequency vector is not 1 (i.e. it is not standardized), the function automatically standardizes the frequency vector by dividing each element of the vector by the sum of the vector. The assumption is that the frequencies are complete. The order of the valures is not taken into consideration.}
\value{Index of polarization (RQ).}
\references{Garcia-Montalvo, Jose, and Marta Reynal-Querol. 2005. Ethnic Polarization, Potential Conflict, and Civil Wars. American Economic Review 95(3): 796-816.

Reynal-Querol, Marta. 2002. Ethnicity, Political Systems, and Civil Wars. Journal of Conflict Resolution 46(1): 29-54.}
\author{Didier Ruedin}
\examples{
# Sample data
V <- c(30,40,210,130,530,50,10)
MRQ(V)
}

\name{Reardon}
\alias{Reardon}
\title{Reardon's entropy}
\description{This function calculates Reardon's (2009) entropy from a frequency vector}
\usage{Reardon(V)}
\arguments{
  \item{V}{Frequency vector}
}
\details{Calculate Reardon's (2009) entropy.
}
\value{measure of entropy}
\references{Reardon, S. 2009. Measures of Ordinal Segregation. Research on Economic Inequality 17:129-55. <DOI: 10.1108/S1049-2585(2009)0000017011>}
\author{Clem Aeppli}
\seealso{\code{\link{disper}}}

\name{compareAgreement}
\alias{compareAgreement}
\title{Compare agreement A with and without simulated coding error}
\description{Calculate agreement in ordered rating scales, and compares this to agreement with simulated coding error.}
\usage{compareAgreement(V, n=500, e=0.01, N=500, pos=FALSE)}
\arguments{
  \item{V}{A vector with an entry for each individual}
  \item{n}{Number of samples in the simulation of coding errors}
  \item{e}{Proportion of samples for which errors are simulated}
  \item{N}{Number of replications for calculating mean and standard deviation}
  \item{pos}{Vector of possible positions. If FALSE, the values occurring in V are set as the possible values}}
\details{This function calculates agreement on a vector, and compares the value with agreement with simulated coding error. It runs the function \code{\link{agreementError}} N times. The other arguments (n, e, pos) are passed down to the \code{agreementError} function.}
\value{The function returns a list with agreement A without simulated coding errors, the mean of agreement with simulated coding error, and the standard deviation of agreement with simulated coding error.}
\author{Didier Ruedin}
\seealso{\code{\link{agreement}}, \code{\link{agreementError}}}
\examples{
# Sample data:
V <- c(1,1,1,1,2,3,3,3,3,4,4,4,4,4,4)
compareAgreement(V)
}

\name{lsquared.variance}
\alias{lsquared.variance}
\title{Approximate variance of Blair and Lacy's lsquared}
\description{Calculate approximate variance of Blair and Lacy's (2000) lsquared}
\usage{lsquared.variance(V)}
\arguments{
  \item{V}{Frequency vector}
}
\details{Helper function to calculate approximate variance of Blair and Lacy's (2000) lsquared.}

\value{Approximate variance of Blair and Lacy's lsquared}
\references{Blair, J., and M. Lacy. 2000. Statistics of Ordinal Variation. Sociological Methods & Research 28 (3): 251-280.}
\author{Clem Aeppli}
\seealso{\code{\link{BlairLacy}}}

\name{dispersion}
\alias{dispersion}
\title{Measures dispersion}
\description{This function measures dispersion in a frequency vector}
\usage{dispersion(V, metric=2)}
\arguments{
  \item{V}{Vector}
  \item{metric}{city block metric}
}
\details{dispersion is 1-concentration}

\value{measure of dispersion}
\author{Clem Aeppli}
\seealso{\code{\link{concentration}}}

\name{collapse}
\alias{collapse}
\title{Reduces a vector to a frequency vector}
\description{Takes a vector and reduces it to a frequency vector.}
\usage{collapse(D,pos=FALSE, na.rm=TRUE)}
\arguments{
  \item{D}{Vector}
  \item{pos}{Optional: position of categories}
  \item{na.rm}{Optional: should NA be removed (TRUE by default)}
}
\details{This function reduces a vector to a frequency vector. This function is very similar to the way \code{table} summarizes vectors, but this function can deal with categories of frequency 0 if the argument \code{pos} is specified. Here we assume a vector with an entry for each individual (the order of the values is ignored). Each entry states the position of an individual. When the number of positions is naturally limited, such as when categorical positions are used, frequency vectors can summarize this information: how many individuals have position 1, how many individuals have position 2, etc. A frequency vector has an entry for each position in the population (sorted in ascending order). Each entry states the number of individuals in the population with this position.

The argument \code{pos} is required if certain positions do not occur in the population (or if there is a chance that they do not occur in a specific sub-population). For example, if we have positions on a 7-point scale, and position 3 never occurs in the population, the argument \code{pos} must be specified. In this case, the argument may be \code{pos=1:7}. We can also use categories more generally, as in \code{c(-3, -1, 0, 0.5, 1, 2, 5)}. Specifying the positions of categories when all positions occur in the population has no side-effects. See the example for an illustration.

By default, missing values (NA) are removed with \code{as.numeric(na.omit())}. This helps with some vectors that include NA that fail otherwise. If NA are maintained with \code{na.rm=FALSE}, they are included as the last category. The argument \code{pos} cannot include NA as a position; NA are removed if the argument \code{pos} is used.}

\value{A frequency vector}
\author{Didier Ruedin}
\seealso{\code{\link{expand}}}
\examples{
V = c(1,1,1,1,1,1,3,3,3,3,4,5,5,5,5)
# summarize using table()
table(V)
# summarize using collapse()
collapse(V)
# assuming possible values (1,2,3,4,5), we get that zero times 2 included:
collapse(V, pos=c(1,2,3,4,5))
}

\name{agreementError}
\alias{agreementError}
\title{Simulated coding error for agreement A}
\description{Calculate agreement in ordered rating scales, but simulates coding error.}
\usage{agreementError(V, n=500, e=0.01, pos=FALSE)}
\arguments{
  \item{V}{A vector with an entry for each individual, not a frequency vector}
  \item{n}{Number of samples in the simulation}
  \item{e}{Proportion of samples for which errors are simulated}
  \item{pos}{Vector of possible positions. If FALSE (default), the values occurring in V are set as the possible values}}
\details{This function calculates agreement A, but simulates coding error. This can be useful to estimate standard errors and central tendency if certain positions are not observed. If all positions are observed in the vector V, bootstrapping can be used to estimate standard errors. If certain positions are not observed, bootstrapping is limited. Take an extreme example: [3 0 0 0 0]. Here we have three observations at the first position, but none at the others. Bootstrapping will always lead to the same agreement score. This can be misleading if coding error can be assumed. For example, if these three observations refer to a `strongly agree' answer, it is usually conceivable that some or all of these answers could refer to `somewhat agree'. This function lets you specify how many of the observations should be assumed to be potentially mis-coded, and calculates agreement accordingly. If an observation is assumed to be potentially mis-coded, it is randomly set to the position to the left, the position to the right, or the position itself. If the first or last observation is chosen, the simulation takes care not to suggest values that could not occur.

You can run the function a few (hundred) times to get summary statistics of the result (mean, median, standard deviation, etc.). The function \code{\link{compareAgreement}} does just this, and compares the result with the agreement score if no coding error is assumed.
}
\value{The function returns the measure of agreement A.}
\author{Didier Ruedin}
\seealso{\code{\link{agreement}}, \code{\link{compareAgreement}}, \code{\link{collapse}}}
\examples{
# Sample data:
V <- c(1,1,1,1,2,3,3,3,3,4,4,4,4,4,4)
# calculate agreement; using collapse() to create the frequency vector
agreement(collapse(V))
# Calculate agreement A with coding error:
agreementError(V)
# Assume that all values could have coding error:
agreementError(V, e=1)
# Run the function a few times and show the mean:
z <- replicate(1000, agreementError(V))
mean(z) 
hist(z) # etc.
# the example mentioned, population vector [3 0 0 0 0]:
V2 <- c(1,1,1)
agreementError(V2, pos=1:5)
# you can also use the compareAgreement function
compareAgreement(V2, pos=1:5)
}

\name{isd}
\alias{isd}
\title{Classify changes over time}
\description{Classify changes over time using the ISD-system introduced by Galtung (1969).}
\usage{isd(V, tolerance=0.1)}
\arguments{
  \item{V}{A vector with length 3}
  \item{tolerance}{Specify how similar values have to be to be treated as different (optional). Differences smaller than or equal to the tolerance are ignored.}
}
\details{This function implements the ISD-system introduced by Galtung (1969). The input is a vector of length 3. Each value stands for a different point in time. The ISD-system examines the two transition points, and classifies the changes over time.}
\value{The function returns a list. The \code{type} returns a number corresponding to the pattern described by Galtung. The \code{description} returns a string where the two transitions are spelled out (increase, flat, decrease).}
\references{Galtung, J. (1969) Theory and Methods of Social Research. Oslo: Universitetsforlaget.}
\author{Didier Ruedin}
\seealso{\code{\link{ajus}}}

\name{BerryMielke}
\alias{BerryMielke}
\title{Calculate IOV}
\description{Calculate Berry and Mielke's IOV.}
\usage{BerryMielke(V)}
\arguments{
  \item{V}{A frequency vector}
}
\details{This function calculates Berry and Mielke's IOV, a measure of dispersion based on squared Euclidean distances. This function follows the presentation by Blair and Lacy 2000, but includes the adjustment for Tmax omitted by Blair and Lacy as there is no reason to leave it out. The derived measure COV by Kvalseth is implemented as \code{\link{Kvalseth}}. Usually, the IOV is equivalent to 1-\code{\link{lsquared}}.}
\value{The function returns the IOV.}
\references{Blair, J., and M. Lacy. 2000. Statistics of Ordinal Variation. Sociological Methods & Research 28 (3): 251-280.

Berry, K., and P. Mielke. 1992. Assessment of Variation in Ordinal Data. Perceptual and Motor Skills 74 (1): 63-66.
}
\author{Didier Ruedin}
\seealso{\code{\link{lsquared}}, \code{\link{Kvalseth}}}
\examples{
# Sample data
V <- c(30,40,210,130,530,50,10)
BerryMielke(V)
}

\name{consensus}
\alias{consensus}
\title{Calculate Tastle and Wierman's measure of consensus}
\description{Calculate consensus in ordered rating scales. This function implements Tastle and Wierman's (2007) measure of consensus (ordinal dispersion), which can be used to describe agreement, consensus, dispersion, or polarization among respondents.}
\usage{consensus(V)}
\arguments{
  \item{V}{A frequency vector}
}
\details{This function calculates consensus following Tastle and Wierman (2007). The measure of consensus is based on the Shannon entropy. A frequency vector describes the number of observations in a given category. For example, the vector [10,20,30,15,4] describes 10 observations with position 1, 20 observations with position 2, 30 observations with position 3, 15 observations with position 4, and 4 observations with position 5.

If you come across an error that the vector supplied does not contain whole numbers, try \code{round(V,0)} to remove any detritus from calculating the frequency vector.}
\value{The function returns the measure of consensus. It is 1 if there is perfect uniformity; it is 0 if there is perfect bimodality (=lack of agreement)}
\references{Tastle, W., and M. Wierman. 2007. Consensus and dissention: A measure of ordinal dispersion. International Journal of Approximate Reasoning 45(3): 531-545.}
\author{Didier Ruedin}
\seealso{\code{\link{agreement}}}
\examples{
# Sample data
V <- c(30,40,210,130,530,50,10)
# Calculate consensus
consensus(V)
# The degree of consensus is given as 0.7256876
}

\name{ajusCheck}
\alias{ajusCheck}
\title{Sensitivity test for AJUS}
\description{Check sensitivity of AJUS to different tolerance parameters.}
\usage{ajusCheck(V, t=seq(from=0.05, to=0.2, by=0.05), variant="modified")}
\arguments{
  \item{V}{A frequency vector}
  \item{t}{A vector of tolerance parameters to check. Differences smaller than or equal to the tolerance are ignored.}
  \item{variant}{Strict AJUS following Galtung, or modified to include F and L types (default)}
}
\details{This function runs the AJUS system with a range of tolerance parameters. This way, you can easily check how sensitive the classification of the distribution is to the tolerance parameter.}
\value{The function returns a list. The \code{tolerance} returns the tolerance parameters tested. The \code{type} returns a series of strings corresponding to the pattern described by Galtung (A,J,U,S) or (F, L) for each tolerance parameter. The \code{skew} returns a number to describe the direction of the skew. See \code{\link{ajus}} for a description of the different arguments and the AJUS types.}
\author{Didier Ruedin}
\seealso{\code{\link{ajus}}}

\name{polarization}
\alias{polarization}
\title{Calculate polarization}
\description{Calculates polarization, based on measure of agreement A}
\usage{polarization(V, old = FALSE)}
\arguments{
  \item{V}{A frequency vector}
  \item{old}{Specify \code{old=TRUE} to use the deprecated algorithm for agreement A}
}
\details{This function calculates polarization by re-scaling agreement A introduced by Cees van der Eijk. Whereas agreement A ranges from -1 to 1, polarization ranges from 0 to 1. If all observations are in the same category, polarization is 0. With half the observations in one category, and half the observations in a different (non-neighbouring) category, polarization is 1. Polarization is 0.5 for a uniform distribution over all categories.}
\value{The function returns a polarization score}
\author{Didier Ruedin}
\seealso{\code{\link{agreement}}}
\examples{
V <- c(30,40,210,130,530,50,10)
# Calculate polarization
polarization(V)
# The rate of polarization is given as 0.1943333
}

\name{Leik}
\alias{Leik}
\title{Calculate ordinal dispersion}
\description{Calculates ordinal dispersion as introduced by Leik (1966)}
\usage{Leik(V)}
\arguments{
  \item{V}{A frequency vector}
}
\details{This function calculates ordinal dispersion as introduced by Robert K. Leik (1966). It uses the cumulative frequency distribution to determine ordinal dispersion. The extremes (agreement, polarization) largely correspond to the types used by Cees van der Eijk. By contrast, the mid-point depends on the number of categories: it tends toward 0.5 as the number of categories increases. Leik defends this difference by highlighting the increased probability of falling into polarized patterns when there are fewer categories. If all observations are in the same category, ordinal dispersion is 0. With half the observations in one extreme category, and half the observations in the other extreme, Leik's measure gives a value of 1.

The dispersion measure is a percentage, and can be interpreted accordingly. Ordinal dispersion can be used to express consensus or agreement, simply by taking: 1 - ordinal dispersion.}
\value{The function returns the ordinal dispersion}
\references{Leik, R. (1966) A measure of ordinal consensus, Pacific Sociological Review 9(2):85-90.}
\author{Didier Ruedin}
\seealso{\code{\link{polarization}}, \code{\link{agreement}}}
\examples{
# Example 1:
V <- c(30,40,210,130,530,50,10)
# Calculate polarization
Leik(V)
# The ordinal dispersion is given as 0.287
polarization(V)
# Polarization is given as 0.194 (as contrast)
}

\name{sd.variance}
\alias{sd.variance}
\title{Approximate variance of the categorical standard deviation}
\description{Calculate approximate variance of the categorical standard deviation}
\usage{sd.variance(V)}
\arguments{
  \item{V}{Frequency vector}
}
\details{Helper function to calculate approximate variance of the categorical standard deviation.}

\value{Approximate variance of the categorical standard deviation}
\author{Clem Aeppli}
\seealso{\code{\link{truncate}}}

\name{agrmt-package}
\alias{agrmt-package}
\alias{agrmt}
\docType{package}
\title{Calculate Concentration and Dispersion in Ordered Rating Scales}
\description{This package calculates concentration and dispersion in ordered rating scales. It implements various measures of concentration and dispersion to describe what researchers variably call agreement, concentration, consensus, dispersion, or polarization among respondents in ordered data. It also implements other related measures to classify distributions.}
\details{In ordered rating scales, concentration occurs if many values on the scale cluster around one value. Dispersion describes the absense of concentration. Various measures exist to calculate concentration and dispersion.

The package provides a generic city-block based (\code{\link{concentration}}) measure, and a generic measure of dispersion (\code{\link{disper}}). To use Van der Eijk's (2001) algorithmic approach agreement "A", call \code{\link{agreement}}. The derived \code{\link{polarization}} lets you calculate a polarization score based on agreement A. Values are inverted and standardized to [0, 1]. Other specific measures: Leik's measure of ordinal dispersion (\code{\link{Leik}}), Tatsle and Wierman's (\code{\link{consensus}}), Blair and Lacy's (\code{\link{dsquared}}, \code{\link{lsquared}}, and \code{\link{BlairLacy}}), the measure by Kvalseth (\code{\link{Kvalseth}}), Berry and Mielke's IOV (\code{\link{BerryMielke}}), Reardon (\code{\link{Reardon}}) or Garcia-Montalvo and Reynal-Querol's (\code{\link{MRQ}}).

The package also includes functions to classify distributions according to Galtung's (1969) AJUS-system (\code{\link{ajus}}), and changes over time according to Galtung's (1969) ISD-system (\code{\link{isd}}). Moreover, the function \code{\link{modes}} can identify the position of multiple modes.}
\author{Didier Ruedin

Contributor: Clem Aeppli

Maintainer: Didier Ruedin <didier.ruedin@unine.ch>
}
\references{van der Eijk, C. (2001) Measuring agreement in ordered rating scales, Quality and Quantity 35(3):325-341.

Galtung, J. (1969) Theory and Methods of Social Research. Oslo: Universitetsforlaget.}
\keyword{ package }

\name{modes}
\alias{modes}
\title{Identify multiple modes}
\description{Identifies (multiple) modes in a frequency vector.}
\usage{modes(V, pos=FALSE, tolerance=0.1)}
\arguments{
  \item{V}{A frequency vector}
  \item{pos}{Categories of frequency vector (optional)}
  \item{tolerance}{Specify how similar values have to be to be treated as different (optional).  Differences smaller than or equal to the tolerance are ignored.}
}
\details{This function identifies which positions of a frequency vector correspond to the mode. If there are multiple modes of the same value, all matching positions will be reported. Use the function \code{\link{collapse}} to create frequency vectors if necessary.}
\value{The function returns a list. The \code{at} returns the categories of the frequency vector. Either these categories were specified using the argument pos, or we assume it to be 1:k (with k the number of categories in the frequency vector). If the length of the \code{pos} argument does not match the length of the frequency vector, a warning is shown, and the \code{pos} argument is ignored. The \code{frequencies} returns the frequency vector. The \code{mode} returns the value of the mode(s). If there are multiple modes, they are listed. Similar frequencies are counted as equal, using the tolerance argument. To prevent similar frequencies to be considered the same, set \code{tolerance} to 0. The \code{positions} returns the positions of the vector that correspond to the mode. This will differ from the \code{mode} if \code{pos} is provided.The \code{contiguous} returns TRUE of all modes are contiguous, and FALSE if there are different values in between. If there is only one mode, it is defined as contiguous (i.e. TRUE).}
\author{Didier Ruedin}
\seealso{\code{\link{secondModes}}}
\examples{
# Example 1: finding the mode
V1 <- c(30,40,210,130,530,50,10)
modes(V1) # will find position 5
# Example 2:
V2 <- c(3,0,4,1)
modes(V2) # will find position 3
# Example 3: providing categories
modes(V2,pos=-1:2) # will still find position 3, but give the value of 1 as mode
# Example 4: similar values
V3 <- c(30,40,500,130,530,50,10) 
modes(V3, tolerance=30) # will find positions 3 and 5 (500 and 530 are nearly the same)
}

\name{agreement}
\alias{agreement}
\title{Calculate van der Eijk's measure of agreement A}
\description{Calculate agreement in ordered rating scales. This function implements van der Eijk's (2001) measure of agreement A, which can be used to describe agreement or consensus among respondents.}
\usage{agreement(V, old = FALSE)}
\arguments{
  \item{V}{A frequency vector}
  \item{old}{Optional argument if you wish to use the deprecated algorithm for agreement A, as outlined in van der Eijk's article. There is normally no reason to set the \code{old} argument.}
}
\details{This is the main function to calculate agreement. A frequency vector describes the number of observations in a given category. For example, the vector [10,20,30,15,4] describes 10 observations with position 1, 20 observations with position 2, 30 observations with position 3, 15 observations with position 4, and 4 observations with position 5. At least three categories are required to calculate agreement.

Polarization can be measured by extension. A convenience function \code{\link{polarization}} is provided.}
\value{The function returns the measure of agreement A. A is 1 if there is perfect unimodality (=agreement); A is 0 if there is perfect uniformity; A is -1 if there is perfect bimodality (=lack of agreement)}
\references{van der Eijk, C. 2001. Measuring agreement in ordered rating scales. Quality and Quantity 35(3):325-341. <DOI: 10.1023/A:1010374114305>}
\author{Didier Ruedin}
\seealso{\code{\link{polarization}}}
\examples{
# Sample data
V <- c(30,40,210,130,530,50,10)
# Calculate agreement A
agreement(V)
# The rate of agreement is given as 0.6113333
}

\name{entropy}
\alias{entropy}
\title{Calculate Shannon entropy}
\description{Calculate Shannon entropy, following Tastle and Wierman.}
\usage{entropy(V)}
\arguments{
  \item{V}{A frequency vector}
}
\details{This function calculates the Shannon entropy following Tastle and Wierman (2007). A frequency vector describes the number of observations in a given category. For example, the vector [10,20,30,15,4] describes 10 observations with position 1, 20 observations with position 2, 30 observations with position 3, 15 observations with position 4, and 4 observations with position 5.

This function follows Tastle and Wierman and ignores categories with zero observations. This does not follow the formula indicated.

See \code{\link{consensus}} for a function that considers the order of categories.}
\value{The function returns the Shannon entropy.}
\references{Tastle, W., and M. Wierman. 2007. Consensus and dissention: A measure of ordinal dispersion. International Journal of Approximate Reasoning 45 (3): 531-545.}
\author{Didier Ruedin}
\seealso{\code{\link{consensus}}}
\examples{
# Sample data
V <- c(30,40,210,130,530,50,10)
# Calculate entropy
entropy(V)
}

\name{secondModes}
\alias{secondModes}
\title{Most common and second most common values}
\description{Identifies the most common (multiple) modes for frequency vectors as well as the second most common values.}
\usage{secondModes(V, pos=FALSE, tolerance=0.1)}
\arguments{
  \item{V}{A frequency vector}
  \item{pos}{Categories of frequency vector (optional)}
  \item{tolerance}{Specify how similar values have to be to be treated as different (optional).  Differences smaller than or equal to the tolerance are ignored.}
}
\details{This function identifies which positions of a frequency vector correspond to the mode(s) as implemented in the \code{\link{modes}} function. It also reports the second most common position in the same manner.}
\value{The function returns a list for the most common and the second most common value(s). The output corresponds to that of the \code{\link{modes}} function.}
\author{Didier Ruedin}
\seealso{\code{\link{modes}}}

\name{ajus}
\alias{ajus}
\title{Classify distributions}
\description{Classify distributions using the AJUS-system introduced by Galtung (1969).}
\usage{ajus(V, tolerance=0.1, variant="modified")}
\arguments{
  \item{V}{A frequency vector}
  \item{tolerance}{Specify how similar values have to be to be treated as different (optional). Differences smaller than or equal to the tolerance are ignored.}
  \item{variant}{Strict AJUS following Galtung, or modified to include F and L types (default)}
}
\details{This function implements the AJUS-system introduced by Galtung (1969). The input is a frequency vector; the output is a classification of the distribution.

Distributions are classified as A if they are unimodal with a peak in the centre, as J if they are unimodal with a peak at either end, as U if they are bimodal with a peak at both ends, and as S if they are multimodal. In addition to Galtung's classification, the function classifies distributions as F if there is no peak and all values are more or less the same (flat). Furthermore, a distinction is drawn between J and L distributions, depending on whether they increase or decrease: J types have a peak on the right, L types have the peak on the left. The skew is given as +1 for a positive skew, as 0 for no skew, and -1 for a negative skew.

The skew is identified by comparing the sum of values left and right of the midpoint respectively. For J-type of distributions, the skew is identified on the basis of the changes between values. This way, long tails cannot influence the skew, and a single peak at the left and right-hand end can be differentiated in all cases.

The aim of the AJUS system is to reduce complexity. Initially the intuition was to classify distributions on an ad-hoc basis (i.e. eye-balling). Using an algorithm is certainly more reliable, and useful if one is interested in classifying (and comparing) a large number of distributions. The argument \code{tolerance}, however is not a trivial choice and can affect results. Use the helper function \code{ajusCheck} to check sensitivity to different values of the tolerance parameter.

You can choose between a strict AJUS classification and a modified AJUSFL classification (default). The AJUS classification does not include a type for distributions without peaks (F type), and NA is returned instead. The AJUS classification does not draw a distinction between unimodal distributions with a peak at the end: the skew needs to be considered to distinguish between increasing and decreasing cases. The modified variant (default) includes the F type and the L type along with the original AJUS types.}
\value{The function returns a list. The \code{type} returns a string corresponding to the pattern described by Galtung (A,J,U,S) or (F,L). The \code{skew} returns a number to describe the direction of the skew. The \code{pattern} returns the simplified pattern of the distribution. It indicates whether two values were considered the same (0), or if there was an increase (1) or decrease (-1) between two consecutive values. The length of the pattern is equal to the length of the frequency vector minus one.}
\references{Galtung, J. (1969) Theory and Methods of Social Research. Oslo: Universitetsforlaget.}
\author{Didier Ruedin}
\seealso{\code{\link{isd}}, \code{\link{ajusCheck}}, \code{\link{ajusPlot}}}

\name{compareValues}
\alias{compareValues}
\title{Compares two values}
\description{This is a helper function to compare two values.}
\usage{compareValues(A,B,tolerance=0.1)}
\arguments{
\item{A}{A number}
\item{B}{A number}
\item{tolerance}{Specify how similar values have to be to be treated as different. Differences smaller than or equal to the tolerance are ignored.}
}
\details{This is a helper function compare two values. Two values are more or less the same, or one of the two is bigger.}
\value{The function returns number to describe the relationship: -1 if A is bigger, 1 if B is bigger, and 0 if the two are more or less the same.}
\author{Didier Ruedin}

\name{concentration}
\alias{concentration}
\title{Measures concentration}
\description{This function measures concentration in a frequency vector}
\usage{concentration(V, metric=2)}
\arguments{
  \item{V}{Vector}
  \item{metric}{city block metric}
}
\details{This function measures concentration in a frequency vector in city blocks. The default metric is 2.}

\value{measure of concentration}
\author{Clem Aeppli}
\examples{
# Sample data
V <- c(30,40,210,130,530,50,10)
concentration(V)
}

\name{censor}
\alias{censor}
\title{Censor helper function}
\description{Helper function to censor frequency vectors}
\usage{censor(V, left=0, right=100)}
\arguments{
  \item{V}{Vector}
  \item{left}{left to censor}
  \item{right}{right to censor}
}
\details{Helper function to censor frequency vectors}

\value{censored frequency vector}
\author{Clem Aeppli}
\seealso{\code{\link{truncate}}}

\name{D.variance}
\alias{D.variance}
\title{Approximate variance of Leik's D}
\description{Calculate approximate variance of Leik's D}
\usage{D.variance(V)}
\arguments{
  \item{V}{Frequency vector}
}
\details{Helper function to calculate approximate variance of Leik's (1966) D.}

\value{Approximate variance of D}
\references{Leik, R. (1966) A measure of ordinal consensus, Pacific Sociological Review 9(2):85-90.}
\author{Clem Aeppli}
\seealso{\code{\link{Leik}}}
